/*
 * Copyright (c) 2000 DSS Distributed Systems Software, Inc.
 * All rights reserved.
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

#include "ndbm.h"

char buf[10240];

int
main(int argc, char **argv)
{
	int nkeys;
	unsigned long nbytes;
	DBM *dbm;
	datum key, value;

    if (argc != 2) {
        fprintf(stderr, "Usage: countndbm ndbm-file\n");
        exit(1);
    }

	if ((dbm = dbm_open(argv[1], O_RDONLY, 0644)) == NULL) {
		fprintf(stderr, "dbm_open error on %s\n", argv[1]);
		exit(1);
	}

	nkeys = 0;
	nbytes = 0;
	for (key = dbm_firstkey(dbm); key.dptr != NULL; key = dbm_nextkey(dbm)) {
		value = dbm_fetch(dbm, key);

		nkeys++;
		nbytes += key.dsize + value.dsize;
	}

	dbm_close(dbm);

	fprintf(stderr, "%d keys, %lu total bytes\n", nkeys, nbytes);
	exit(0);
}

