/*
 * Copyright (c) 2000 DSS Distributed Systems Software, Inc.
 * All rights reserved.
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

#define DB_DBM_HSEARCH    1
#include "db.h"

char buf[102400];

static void del_words(DBM *dbm);

int
main(int argc, char **argv)
{
	DBM *dbm;

    if (argc != 2) {
        fprintf(stderr, "Usage: deldb db-file\n");
        exit(1);
    }

	if ((dbm = dbm_open(argv[1], O_CREAT|O_RDWR, 0644)) == NULL) {
		fprintf(stderr, "Open error\n");
		exit(1);
	}

    del_words(dbm);

	dbm_close(dbm);

	exit(0);
}

int nwords;

static void
del_words(DBM *dbm)
{
  int len, rc;
  datum key;

  nwords = 0;
  while (fgets(buf, sizeof(buf), stdin) != NULL) {
    len = strlen(buf);
    len--;
    buf[len] = '\0';
    key.dptr = buf;
    key.dsize = len + 1;;

    rc = dbm_delete(dbm, key);
    if (rc == -1) {
      fprintf(stderr, "Failed\n");
      fprintf(stderr, "Key: %s\n", buf);
	  return;
    }
    else
      nwords++;
  }
  fprintf(stderr, "Deleted %d items\n", nwords);
}
