/*
 * Copyright (c) 2000 DSS Distributed Systems Software, Inc.
 * All rights reserved.
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

#include "/k/generic/include/gdbm/gdbm.h"

char buf[102400];

static void del_words(GDBM_FILE dbm);

int
main(int argc, char **argv)
{
	GDBM_FILE dbm;

    if (argc != 2) {
        fprintf(stderr, "Usage: delgdbm gdbm-file\n");
        exit(1);
    }

	if ((dbm = gdbm_open(argv[1], 0, GDBM_WRCREAT, 0644, 0)) == NULL) {
		fprintf(stderr, "Open error\n");
		exit(1);
	}

    del_words(dbm);

	gdbm_close(dbm);

	exit(0);
}

int nwords;

static void
del_words(GDBM_FILE dbm)
{
  int len, rc;
  datum key;

  nwords = 0;
  while (fgets(buf, sizeof(buf), stdin) != NULL) {
    len = strlen(buf);
    len--;
    buf[len] = '\0';
    key.dptr = buf;
	key.dsize = len + 1;;

    rc = gdbm_delete(dbm, key);
    if (rc == -1) {
      fprintf(stderr, "Failed\n");
      fprintf(stderr, "Key: %s\n", buf);
	  return;
    }
    else
      nwords++;
  }
  fprintf(stderr, "Deleted %d items\n", nwords);
}

