/*
 * Copyright (c) 2000 DSS Distributed Systems Software, Inc.
 * All rights reserved.
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>

#include "ndbm.h"

char buf[102400];

static void add_words(DBM *dbm, int flag);

int
main(int argc, char **argv)
{
	DBM *dbm;

    if (argc != 3) {
        fprintf(stderr, "Usage: mkndbm -w[kv=] ndbm-file\n");
        exit(1);
    }

	if ((dbm = dbm_open(argv[2], O_CREAT|O_RDWR|O_TRUNC, 0644)) == NULL) {
		fprintf(stderr, "error\n");
		exit(1);
	}

    add_words(dbm, argv[1][2]);

	dbm_close(dbm);

	exit(0);
}

int nwords;

static void
add_words(DBM *dbm, int flag)
{
  int len, rc;
  char v[10];
  datum key, value;

  nwords = 0;
  while (fgets(buf, sizeof(buf), stdin) != NULL) {
    len = strlen(buf);
    len--;
    buf[len] = '\0';
    sprintf(v, "%d", nwords);
    if (flag == '\0' || flag == 'k') {
	  key.dptr = buf;
	  key.dsize = len + 1;;
	  value.dptr = v;
	  value.dsize = strlen(v) + 1;;
    }
    else if (flag == '=') {
	  key.dptr = buf;
	  key.dsize = len + 1;;
	  value.dptr = buf;
	  value.dsize = len + 1;;
    }
    else {
	  key.dptr = v;
	  key.dsize = strlen(v) + 1;;
	  value.dptr = buf;
	  value.dsize = len + 1;;
    }
    rc = dbm_store(dbm, key, value, DBM_INSERT);
    if (rc == -1) {
      fprintf(stderr, "Failed\n");
      fprintf(stderr, "Key: %s\n", buf);
    }
    else
      nwords++;
  }
  fprintf(stderr, "Added %d items\n", nwords);
}

