/*
 * Copyright (c) 2000 DSS Distributed Systems Software, Inc.
 * All rights reserved.
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

/*
 * Basic fetch test
 *   arg1: a key
 */

#include <stdio.h>

#include "dx.h"

/* extern struct stats stats; */

Dx_len
iofunc(void *arg, void *dptr, Dx_len dlen, Dx_desc *desc)
{
  int x;

  x = (int) arg;
  fprintf(stderr, "`%s' (%lu bytes, desc=%u)\n",
		  (char *) dptr, dlen, desc->flags);
  return(dlen);
}

int
main(int argc, char **argv)
{
  char *volumes[10];
  Dx_datum key, value;
  Dx *db;
  Dx_config config;
  Dx_opmode mode;
  Dx_user_io uio;
  Dx_rc rc;

  volumes[0] = "../db1";
  volumes[1] = "../db2";
  volumes[2] = "../db3";
  volumes[3] = NULL;
  Dx_get_configuration(NULL, &config);
  config.flags |= DX_CONFIG_DEFAULT_FLAGS;

  if ((rc = Dx_open(volumes, &config, &db)) != DX_OK) {
	fprintf(stderr, "%s\n", Dx_strerror(rc));
	exit(1);
  }

  Dx_key(&key, argv[1], strlen(argv[1]) + 1);
  uio.func = iofunc;
  uio.arg = (void *) 17;
  if ((rc = Dx_fetchx(db, &key, DX_FETCH | DX_UIO, &uio)) != DX_OK) {
	fprintf(stderr, "%s\n", Dx_strerror(rc));
	exit(1);
  }

  if ((rc = Dx_fetchx(db, &key, DX_FETCH, &value)) != DX_OK) {
	fprintf(stderr, "%s\n", Dx_strerror(rc));
	exit(1);
  }

  fprintf(stderr, "`%s' (%lu bytes, desc=%u)\n",
		  (char *) value.dptr, (unsigned long) value.dlen, value.flags);

  if ((rc = Dx_close(db)) != DX_OK) {
	fprintf(stderr, "%s\n", Dx_strerror(rc));
	exit(1);
  }

  exit(0);
}

