/*
 * Copyright (c) 2000 DSS Distributed Systems Software, Inc.
 * All rights reserved.
 *
 * See the file "LICENSE" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

#include <stdio.h>

#include "dx.h"

int do_max = 1;
int do_big = 6543210;

/* extern struct stats stats; */

Dx_len
iofunc(void *arg, void *dptr, Dx_len io_dlen, Dx_desc *desc)
{
  int ch;
  Dx_ui8 *p;
  Dx_len i, n, need;
  static int first = 1;

  ch = (int) arg;
  p = (Dx_ui8 *) dptr;

  if (do_big) {
	if (do_big <= io_dlen)
	  need = do_big;
	else
	  need = io_dlen;
	do_big -= need;
	n = (do_big == 0) ? (need - 1) : need;
	for (i = 0; i < n; i++)
	  *p++ = ch;
	if (do_big == 0)
	  *p = '\0';

	first = 0;
	return(need);
  }

  if (!first)
    return(0);

  if (do_max) {
    for (i = 0; i < (io_dlen - 1); i++)
      *p++ = ch;
  }
  else {
    for (i = 0; i < 10 && i < io_dlen; i++)
      *p++ = ch;
  }
  if (io_dlen > 0)
    *p = '\0';

  first = 0;

  if (do_max)
	return(io_dlen);
  return(11);
}

int
main(int argc, char **argv)
{
  int do_edit, do_insert, do_io, i;
  char *volumes[10];
  Dx_datum key, value;
  Dx *db;
  Dx_config config;
  Dx_opmode mode;
  Dx_point chunk;
  Dx_region edit;
  Dx_user_io uio;
  Dx_rc rc;

  volumes[0] = "../db1";
  volumes[1] = "../db2";
  volumes[2] = "../db3";
  volumes[3] = NULL;
  Dx_get_configuration(NULL, &config);
  config.flags |= DX_CONFIG_TRUNCATE_ON_OPEN;

  if ((rc = Dx_open(volumes, &config, &db)) != DX_OK) {
	fprintf(stderr, "%s\n", Dx_strerror(rc));
	exit(1);
  }

  Dx_key(&key, argv[1], strlen(argv[1]) + 1);

  uio.func = iofunc;
  uio.arg = (void *) 'b';

  rc = Dx_storex(db, &key, DX_INSERT | DX_UIO, NULL, &uio);
  if (rc != DX_OK) {
	  fprintf(stderr, "%s\n", Dx_strerror(rc));
	  exit(1);
  }

  if ((rc = Dx_close(db)) != DX_OK) {
	fprintf(stderr, "%s\n", Dx_strerror(rc));
	exit(1);
  }

  exit(0);
}

